// $ANTLR 3.0.1 D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g 2008-04-22 09:12:15

/*--------------------------------------------------------------------------
 *  Copyright 2007 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------------------
// xerial-wiki project
// 
// WikiWalker.java
// Since  2007/09/08 23:17:42
// 
//--------------------------------------------------
package org.xerial.wiki.impl;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

import org.antlr.stringtemplate.*;
import org.antlr.stringtemplate.language.*;
import java.util.HashMap;
public class WikiWalker extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "Wiki", "WikiBlock", "WikiLine", "Text", "Path", "Function", "AssignTo", "String", "Array", "Hash", "PreservedBlock", "XMLElement", "XMLAttribute", "ML_COMMENT", "NEWLINE", "LINE_COMMENT", "UpperLetter", "LowerLetter", "Letter", "Digit", "HexDigit", "UnicodeChar", "EscapeSequence", "StringChar", "Int", "Dot", "Frac", "Exp", "WhiteSpace", "BlankLine", "WhiteSpaces", "H1", "H2", "H3", "I1", "I2", "I3", "NameChar", "Name", "LParen", "RParen", "LBracket", "RBracket", "LBrace", "RBrace", "Lt", "Gt", "Slash", "At", "Comma", "Colon", "Eq", "Star", "StringCharacters", "StringLiteral", "Symbol", "WikiBlockSymbol", "ProtocolPrefix", "URLChar", "URLQueryChar", "CloseTagBegin", "WikiName", "InternetLink", "FunctionID", "FunctionName", "Word", "PreText", "'\"'", "HyperLink", "WikiLink"
    };
    public static final int LBrace=47;
    public static final int XMLAttribute=16;
    public static final int UpperLetter=20;
    public static final int CloseTagBegin=64;
    public static final int InternetLink=66;
    public static final int Frac=30;
    public static final int PreservedBlock=14;
    public static final int StringCharacters=57;
    public static final int URLChar=62;
    public static final int I3=40;
    public static final int Array=12;
    public static final int I1=38;
    public static final int I2=39;
    public static final int Path=8;
    public static final int Gt=50;
    public static final int Hash=13;
    public static final int HyperLink=72;
    public static final int RBracket=46;
    public static final int Wiki=4;
    public static final int EOF=-1;
    public static final int FunctionName=68;
    public static final int HexDigit=24;
    public static final int URLQueryChar=63;
    public static final int Int=28;
    public static final int Lt=49;
    public static final int ML_COMMENT=17;
    public static final int FunctionID=67;
    public static final int WhiteSpace=32;
    public static final int Symbol=59;
    public static final int String=11;
    public static final int LBracket=45;
    public static final int WikiBlock=5;
    public static final int RBrace=48;
    public static final int RParen=44;
    public static final int ProtocolPrefix=61;
    public static final int At=52;
    public static final int XMLElement=15;
    public static final int WikiBlockSymbol=60;
    public static final int LParen=43;
    public static final int LINE_COMMENT=19;
    public static final int WhiteSpaces=34;
    public static final int BlankLine=33;
    public static final int NameChar=41;
    public static final int Exp=31;
    public static final int Eq=55;
    public static final int WikiLink=73;
    public static final int Word=69;
    public static final int Colon=54;
    public static final int UnicodeChar=25;
    public static final int Digit=23;
    public static final int WikiLine=6;
    public static final int StringLiteral=58;
    public static final int NEWLINE=18;
    public static final int Function=9;
    public static final int WikiName=65;
    public static final int Name=42;
    public static final int Dot=29;
    public static final int PreText=70;
    public static final int Text=7;
    public static final int StringChar=27;
    public static final int H3=37;
    public static final int H2=36;
    public static final int H1=35;
    public static final int AssignTo=10;
    public static final int Star=56;
    public static final int Comma=53;
    public static final int EscapeSequence=26;
    public static final int Letter=22;
    public static final int Slash=51;
    public static final int LowerLetter=21;

        public WikiWalker(TreeNodeStream input) {
            super(input);
        }
        
    protected StringTemplateGroup templateLib =
      new StringTemplateGroup("WikiWalkerTemplates", AngleBracketTemplateLexer.class);

    public void setTemplateLib(StringTemplateGroup templateLib) {
      this.templateLib = templateLib;
    }
    public StringTemplateGroup getTemplateLib() {
      return templateLib;
    }
    /** allows convenient multi-value initialization:
     *  "new STAttrMap().put(...).put(...)"
     */
    public static class STAttrMap extends HashMap {
      public STAttrMap put(String attrName, Object value) {
        super.put(attrName, value);
        return this;
      }
      public STAttrMap put(String attrName, int value) {
        super.put(attrName, new Integer(value));
        return this;
      }
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g"; }

    
    	private StringBuilder builder = new StringBuilder();
    
    


    public static class wiki_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start wiki
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:43:1: wiki : ^( Wiki ( wikiExpr )* ) ;
    public final wiki_return wiki() throws RecognitionException {
        wiki_return retval = new wiki_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:44:2: ( ^( Wiki ( wikiExpr )* ) )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:44:4: ^( Wiki ( wikiExpr )* )
            {
            match(input,Wiki,FOLLOW_Wiki_in_wiki58); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:44:11: ( wikiExpr )*
                loop1:
                do {
                    int alt1=2;
                    int LA1_0 = input.LA(1);

                    if ( ((LA1_0>=WikiBlock && LA1_0<=WikiLine)) ) {
                        alt1=1;
                    }


                    switch (alt1) {
                	case 1 :
                	    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:44:11: wikiExpr
                	    {
                	    pushFollow(FOLLOW_wikiExpr_in_wiki60);
                	    wikiExpr();
                	    _fsp--;


                	    }
                	    break;

                	default :
                	    break loop1;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end wiki

    public static class wikiExpr_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start wikiExpr
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:47:1: wikiExpr : ( wikiLine | wikiBlock );
    public final wikiExpr_return wikiExpr() throws RecognitionException {
        wikiExpr_return retval = new wikiExpr_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:48:2: ( wikiLine | wikiBlock )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==WikiLine) ) {
                alt2=1;
            }
            else if ( (LA2_0==WikiBlock) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("47:1: wikiExpr : ( wikiLine | wikiBlock );", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:48:4: wikiLine
                    {
                    pushFollow(FOLLOW_wikiLine_in_wikiExpr73);
                    wikiLine();
                    _fsp--;


                    }
                    break;
                case 2 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:49:4: wikiBlock
                    {
                    pushFollow(FOLLOW_wikiBlock_in_wikiExpr78);
                    wikiBlock();
                    _fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end wikiExpr

    public static class wikiLine_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start wikiLine
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:52:1: wikiLine : ^( WikiLine ( wikiText )* ) ;
    public final wikiLine_return wikiLine() throws RecognitionException {
        wikiLine_return retval = new wikiLine_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:53:2: ( ^( WikiLine ( wikiText )* ) )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:53:4: ^( WikiLine ( wikiText )* )
            {
            match(input,WikiLine,FOLLOW_WikiLine_in_wikiLine92); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:53:15: ( wikiText )*
                loop3:
                do {
                    int alt3=2;
                    int LA3_0 = input.LA(1);

                    if ( (LA3_0==Text||LA3_0==PreservedBlock||(LA3_0>=HyperLink && LA3_0<=WikiLink)) ) {
                        alt3=1;
                    }


                    switch (alt3) {
                	case 1 :
                	    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:53:15: wikiText
                	    {
                	    pushFollow(FOLLOW_wikiText_in_wikiLine94);
                	    wikiText();
                	    _fsp--;


                	    }
                	    break;

                	default :
                	    break loop3;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end wikiLine

    public static class wikiText_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start wikiText
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:56:1: wikiText : ( Text | HyperLink | PreservedBlock | WikiLink );
    public final wikiText_return wikiText() throws RecognitionException {
        wikiText_return retval = new wikiText_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:57:2: ( Text | HyperLink | PreservedBlock | WikiLink )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:
            {
            if ( input.LA(1)==Text||input.LA(1)==PreservedBlock||(input.LA(1)>=HyperLink && input.LA(1)<=WikiLink) ) {
                input.consume();
                errorRecovery=false;
            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_wikiText0);    throw mse;
            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end wikiText

    public static class wikiLink_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start wikiLink
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:63:1: wikiLink : ^( WikiLink Word ) ;
    public final wikiLink_return wikiLink() throws RecognitionException {
        wikiLink_return retval = new wikiLink_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:64:2: ( ^( WikiLink Word ) )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:64:4: ^( WikiLink Word )
            {
            match(input,WikiLink,FOLLOW_WikiLink_in_wikiLink135); 

            match(input, Token.DOWN, null); 
            match(input,Word,FOLLOW_Word_in_wikiLink137); 

            match(input, Token.UP, null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end wikiLink

    public static class wikiBlock_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start wikiBlock
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:67:1: wikiBlock : ^( WikiBlock ( wikiText )* ) ;
    public final wikiBlock_return wikiBlock() throws RecognitionException {
        wikiBlock_return retval = new wikiBlock_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:68:2: ( ^( WikiBlock ( wikiText )* ) )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:68:4: ^( WikiBlock ( wikiText )* )
            {
            match(input,WikiBlock,FOLLOW_WikiBlock_in_wikiBlock151); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:68:16: ( wikiText )*
                loop4:
                do {
                    int alt4=2;
                    int LA4_0 = input.LA(1);

                    if ( (LA4_0==Text||LA4_0==PreservedBlock||(LA4_0>=HyperLink && LA4_0<=WikiLink)) ) {
                        alt4=1;
                    }


                    switch (alt4) {
                	case 1 :
                	    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:68:16: wikiText
                	    {
                	    pushFollow(FOLLOW_wikiText_in_wikiBlock153);
                	    wikiText();
                	    _fsp--;


                	    }
                	    break;

                	default :
                	    break loop4;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end wikiBlock

    public static class function_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start function
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:72:1: function : ^( Function ( argExpr )* ) ;
    public final function_return function() throws RecognitionException {
        function_return retval = new function_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:73:2: ( ^( Function ( argExpr )* ) )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:73:4: ^( Function ( argExpr )* )
            {
            match(input,Function,FOLLOW_Function_in_function169); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:73:15: ( argExpr )*
                loop5:
                do {
                    int alt5=2;
                    int LA5_0 = input.LA(1);

                    if ( ((LA5_0>=Path && LA5_0<=Function)||(LA5_0>=String && LA5_0<=Hash)) ) {
                        alt5=1;
                    }


                    switch (alt5) {
                	case 1 :
                	    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:73:15: argExpr
                	    {
                	    pushFollow(FOLLOW_argExpr_in_function171);
                	    argExpr();
                	    _fsp--;


                	    }
                	    break;

                	default :
                	    break loop5;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end function

    public static class argExpr_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start argExpr
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:76:1: argExpr : ( String | ^( Array ( argExpr )* ) | ^( Hash ( hashEntry )* ) | Path | function );
    public final argExpr_return argExpr() throws RecognitionException {
        argExpr_return retval = new argExpr_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:77:2: ( String | ^( Array ( argExpr )* ) | ^( Hash ( hashEntry )* ) | Path | function )
            int alt8=5;
            switch ( input.LA(1) ) {
            case String:
                {
                alt8=1;
                }
                break;
            case Array:
                {
                alt8=2;
                }
                break;
            case Hash:
                {
                alt8=3;
                }
                break;
            case Path:
                {
                alt8=4;
                }
                break;
            case Function:
                {
                alt8=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("76:1: argExpr : ( String | ^( Array ( argExpr )* ) | ^( Hash ( hashEntry )* ) | Path | function );", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:77:4: String
                    {
                    match(input,String,FOLLOW_String_in_argExpr185); 

                    }
                    break;
                case 2 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:78:4: ^( Array ( argExpr )* )
                    {
                    match(input,Array,FOLLOW_Array_in_argExpr191); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:78:12: ( argExpr )*
                        loop6:
                        do {
                            int alt6=2;
                            int LA6_0 = input.LA(1);

                            if ( ((LA6_0>=Path && LA6_0<=Function)||(LA6_0>=String && LA6_0<=Hash)) ) {
                                alt6=1;
                            }


                            switch (alt6) {
                        	case 1 :
                        	    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:78:12: argExpr
                        	    {
                        	    pushFollow(FOLLOW_argExpr_in_argExpr193);
                        	    argExpr();
                        	    _fsp--;


                        	    }
                        	    break;

                        	default :
                        	    break loop6;
                            }
                        } while (true);


                        match(input, Token.UP, null); 
                    }

                    }
                    break;
                case 3 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:79:4: ^( Hash ( hashEntry )* )
                    {
                    match(input,Hash,FOLLOW_Hash_in_argExpr201); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:79:11: ( hashEntry )*
                        loop7:
                        do {
                            int alt7=2;
                            int LA7_0 = input.LA(1);

                            if ( (LA7_0==AssignTo) ) {
                                alt7=1;
                            }


                            switch (alt7) {
                        	case 1 :
                        	    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:79:11: hashEntry
                        	    {
                        	    pushFollow(FOLLOW_hashEntry_in_argExpr203);
                        	    hashEntry();
                        	    _fsp--;


                        	    }
                        	    break;

                        	default :
                        	    break loop7;
                            }
                        } while (true);


                        match(input, Token.UP, null); 
                    }

                    }
                    break;
                case 4 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:80:4: Path
                    {
                    match(input,Path,FOLLOW_Path_in_argExpr210); 

                    }
                    break;
                case 5 :
                    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:81:4: function
                    {
                    pushFollow(FOLLOW_function_in_argExpr215);
                    function();
                    _fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end argExpr

    public static class hashEntry_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start hashEntry
    // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:84:1: hashEntry : ^( AssignTo argExpr ) ;
    public final hashEntry_return hashEntry() throws RecognitionException {
        hashEntry_return retval = new hashEntry_return();
        retval.start = input.LT(1);

        try {
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:85:2: ( ^( AssignTo argExpr ) )
            // D:\\cygwin\\home\\leo\\work\\eclipse\\workspace\\XerialJ\\xerial-wiki\\src\\main\\java\\org\\xerial\\wiki\\impl\\WikiWalker.g:85:4: ^( AssignTo argExpr )
            {
            match(input,AssignTo,FOLLOW_AssignTo_in_hashEntry228); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_argExpr_in_hashEntry230);
            argExpr();
            _fsp--;


            match(input, Token.UP, null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end hashEntry


 

    public static final BitSet FOLLOW_Wiki_in_wiki58 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_wikiExpr_in_wiki60 = new BitSet(new long[]{0x0000000000000068L});
    public static final BitSet FOLLOW_wikiLine_in_wikiExpr73 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_wikiBlock_in_wikiExpr78 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WikiLine_in_wikiLine92 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_wikiText_in_wikiLine94 = new BitSet(new long[]{0x0000000000004088L,0x0000000000000300L});
    public static final BitSet FOLLOW_set_in_wikiText0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WikiLink_in_wikiLink135 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_Word_in_wikiLink137 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_WikiBlock_in_wikiBlock151 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_wikiText_in_wikiBlock153 = new BitSet(new long[]{0x0000000000004088L,0x0000000000000300L});
    public static final BitSet FOLLOW_Function_in_function169 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_argExpr_in_function171 = new BitSet(new long[]{0x0000000000003B08L});
    public static final BitSet FOLLOW_String_in_argExpr185 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Array_in_argExpr191 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_argExpr_in_argExpr193 = new BitSet(new long[]{0x0000000000003B08L});
    public static final BitSet FOLLOW_Hash_in_argExpr201 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_hashEntry_in_argExpr203 = new BitSet(new long[]{0x0000000000000408L});
    public static final BitSet FOLLOW_Path_in_argExpr210 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_function_in_argExpr215 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AssignTo_in_hashEntry228 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_argExpr_in_hashEntry230 = new BitSet(new long[]{0x0000000000000008L});

}