/*--------------------------------------------------------------------------
 *  Copyright 2008 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ
//
// BeginVerbatim.java
// Since: Apr 22, 2008 5:34:27 PM
//
// $URL$
// $Author$
//--------------------------------------
package org.xerial.wiki.plugin;

import org.xerial.wiki.WikiContext;
import org.xerial.wiki.WikiException;
import org.xerial.wiki.WikiPlugin;
import org.xerial.wiki.WikiWriter;

/**
 * Begin verbatim (pre) tag
 * 
 * @author leo
 * 
 */
public class BeginVerbatim implements WikiPlugin
{

    public void eval(String[] args, WikiContext context, WikiWriter writer) throws WikiException
    {
        writer.beginVerbatim();
        context.setVerbatimBlock(true);
    }

}
