/*--------------------------------------------------------------------------
 *  Copyright 2008 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ
//
// EndItem.java
// Since: Apr 22, 2008 2:30:57 PM
//
// $URL: https://www.xerial.org/svn/project/XerialJ/trunk/xerial-wiki/src/main/java/org/xerial/wiki/plugin/EndUnorderedListItem.java $
// $Author: leo $
//--------------------------------------
package org.xerial.wiki.plugin;

import org.xerial.wiki.WikiContext;
import org.xerial.wiki.WikiException;
import org.xerial.wiki.WikiPlugin;
import org.xerial.wiki.WikiWriter;

/**
 * Ending item element
 * 
 * @author leo
 * 
 */
public class EndUnorderedListItem implements WikiPlugin
{
    public void eval(String[] args, WikiContext context, WikiWriter writer) throws WikiException
    {
        writer.endItem();
    }


}
