/*--------------------------------------------------------------------------
 *  Copyright 2008 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ
//
// WikiText.java
// Since: Apr 22, 2008 3:43:35 PM
//
// $URL: https://www.xerial.org/svn/project/XerialJ/trunk/xerial-wiki/src/main/java/org/xerial/wiki/WikiText.java $
// $Author: leo $
//--------------------------------------
package org.xerial.wiki;

public class WikiText implements WikiElement
{
    private final String text;

    public WikiText(String text)
    {
        this.text = text;
    }

    @Override
    public String toString()
    {
        return text;
    }

    public WikiElementType getType()
    {
        return WikiElementType.Text;
    }
}
